TITLE           TRASFERIMENTO PATCHS D 50 ROLAND - COMPUTER
 
DATAPORT        EQU     330H
STATPORT        EQU     331H
DRS             EQU     80H
DRR             EQU     40H
ACK             EQU     0FEH
DT1             EQU     12H
RQ1             EQU     11H
ENDEXCLU        EQU     0F7H
 
DSEG            SEGMENT PARA PUBLIC 'DATA'
 
;DATI TONI   IN OGNI BLOCCO 64 DATI + PARITA
ADDUPARZ1       DB  00H,00H,00H
UPARZ1          DB  77 DUP(0FFH)
ADDUPARZ2       DB  00H,00H,40H
UPARZ2          DB  77 DUP(0FFH)
ADDUCOMMON      DB  00H,01H,00H
UCOMMON         DB  77 DUP(0FFH)
ADDLPARZ1       DB  00H,01H,40H
LPARZ1          DB  77 DUP(0FFH)
ADDLPARZ2       DB  00H,02H,00H
LPARZ2          DB  77 DUP(0FFH)
ADDLCOMMON      DB  00H,02H,40H
LCOMMON         DB  77 DUP(0FFH)
ADDPATCH        DB  00H,03H,00H
PATCH           DB  77 DUP(0FFH)
 
;REGISTRI MIDI
COMBFR          DB      00H
ADDRESS1        DB      00H
ADDRESS2        DB      00H
ADDRESS3        DB      00H
PARITY          DB      00H
 
 
;STAMPA E FILES
TITOLO          DB 0DH,0AH,'        =========== PROGRAMMA PER COPIARE UN PATCH D50 ===========',0DH,0AH
                DB '                     SERGIO  STEFFE   -  GENNAIO  1990.     ',0DH,0AH,0DH,0AH,'$'
MENU            DB 0DH,0AH,'        ==========================================================',0DH,0AH,
                DB         '       ===========              M E N U               ===========',0DH,0AH,
                DB         '       ==========================================================',0DH,0AH,
                DB 0DH,0AH
                DB         '                    1. USCITA DAL PROGRAMMA',0DH,0AH
                DB         '                    2. LETTURA PATCH DAL ROLAND',0DH,0AH
                DB         '                    3. SCRITTURA PATCH SUL ROLAND',0DH,0AH
                DB         '                    4. ASSEGNA NOME FILE',0DH,0AH
                DB         '                    5. LEGGI PATCH DAL FILE',0DH,0AH
                DB         '                    6. SCRIVI PATCH SUL FILE',0DH,0AH
                DB  0DH,0AH,0DH,0AH,'$'
MESSROLAND1     DB 'Patch trasferito dal Roland D 50 in memoria del Computer                  ',0DH,'$'
MESSROLAND2     DB 'Patch trasferito dalla memoria del Computer nel Roland D 50               ',0DH,'$'
BLANKLINE       DB '                                                                          ',0DH,'$'
MESSFILE0       DB 'Assegna il nome del FILE da usare :','$'
MESSFILE1       DB 'NON POSSO CREARE IL FILE !                        ',0DH,'$'
MESSFILE2       DB 'Esiste gi un FILE con questo nome ;$'
MESSFILE3       DB 'registro SOPRA ? (S/N)            ',0DH,'$'
MESSFILE4       DB 'File scritto sul disco                                     ',0DH,'$'
MESSFILE5       DB 'NON POSSO APRIRE IL FILE !                                 ',0DH,'$'
MESSFILE6       DB 'File letto dal disco                                       ',0DH,'$'
MESSFILE7       DB 'Attuale nome del FILE  : NEWPATCH',0DH,'$'
MESSFILE8       DB 'NON SONO RIUSCITO A LEGGERE IL FILE  ',0DH,'$'
MESSFILE9       DB 'NON SONO RIUSCITO A SCRIVERE IL FILE ',0DH,'$'
 
CRLF            DB 0DH,0AH,'$'
 
BUFFER          DB      00H
NOMEFILE        DB      'NEWPATCH',32 DUP(00H)
FHANDLE         DW      00H
 
HEXDECI         DB      '   $  1$  2$  3$  4$  5$  6$  7$  8$  9$ 10$ 11$ 12$ 13$ 14$ 15$ 16$ 17$ 18$ 19$'
                DB      ' 20$ 21$ 22$ 23$ 24$ 25$ 26$ 27$ 28$ 29$ 30$ 31$ 32$ 33$ 34$ 35$ 36$ 37$ 38$ 39$'
                DB      ' 40$ 41$ 42$ 43$ 44$ 45$ 46$ 47$ 48$ 49$ 50$ 51$ 52$ 53$ 54$ 55$ 56$ 57$ 58$ 59$'
                DB      ' 60$ 61$ 62$ 63$ 64$ 65$ 66$ 67$ 68$ 69$ 70$ 71$ 72$ 73$ 74$ 75$ 76$ 77$ 78$ 79$'
                DB      ' 80$ 81$ 82$ 83$ 84$ 85$ 86$ 87$ 88$ 89$ 90$ 91$ 92$ 93$ 94$ 95$ 96$ 97$ 98$ 99$'
                DB      '100$101$102$103$104$105$106$107$108$109$110$111$112$113$114$115$116$117$118$119$'
                DB      '120$121$122$123$124$125$126$127$128$129$130$131$132$133$134$135$136$137$138$139$'
                DB      '140$141$142$143$144$145$146$147$148$149$150$151$152$153$154$155$156$157$158$159$'
                DB      '160$161$162$163$164$165$166$167$168$169$170$171$172$173$174$175$176$177$178$179$'
                DB      '180$181$182$183$184$185$186$187$188$189$190$191$192$193$194$195$196$197$198$199$'
                DB      '200$201$202$203$204$205$206$207$208$209$210$211$212$213$214$215$216$217$218$219$'
                DB      '220$221$222$223$224$225$226$227$228$229$230$231$232$233$234$235$236$237$238$239$'
                DB      '240$241$242$243$244$245$246$247$248$249$250$251$252$253$254$255$256$'
 
;
 
DSEG            ENDS
 
CSEG            SEGMENT PARA PUBLIC 'CODE'
                ASSUME CS:CSEG,SS:STACK         ;ALREADY SET BY DOS LOADER
                ASSUME  DS:DSEG ,ES:DSEG        ;TELL ASSEMBLER WHAT I JUST DID
 
                ;FORNISCE DATO MIDI IN AL
GETDATA         PROC    FAR
                PUSH    DX
                MOV     DX,STATPORT     ;DX=STATPORT
LOOP1:          IN      AL,DX           ;READ STATUS
                push    ax
                push    dx
                mov     ah,0bh
                int     21h
                pop     dx
                pop     ax
                ROL     AL,1            ;PUT BIT 7 -> CARRY
                JB      LOOP1           ;IF CARRY=1 THEN NOT READY
                DEC     DX              ;ELSE DX=DATAPORT
                IN      AL,DX           ;READ DATA
                POP     DX
                RET                     ;RETURN TO CALLER
GETDATA         ENDP
 
                ;SPEDISCE COMANDO ALLA MPU
                ;DALLA LOCAZIONE COMBFR
PUTCMD          PROC    FAR
                PUSH    AX
                PUSH    DX
                MOV     DX,STATPORT     ;DX=STATPORT=COMPORT
LBL1:           IN      AL,DX           ;READ STSTUS
                TEST    AL,DRR          ;IF BIT 6 = 1
                JNZ     LBL1            ;THEN KEEP TRYING
                CLI                     ;DISABLE INTERRUPTS
                MOV     AL,COMBFR       ;GET MPU COMMAND
                OUT     DX,AL           ;OUTPUT TO COMPORT
LBL2:           CALL    GETDATA         ;CHECK FOR ACK
                CMP     AL,ACK          ;COMMAND ACKNOWLEDGE?
                JZ      LBL3            ;TAKE IF ACK IS RECEIVED
                JMP     LBL2            ;TRY FOR ACK AGAIN
LBL3:           POP     DX
                POP     AX
                STI                     ;ENABLE INTERRUPTS
                RET                     ;RETURN TO CALLER
PUTCMD          ENDP
 
                ;METTE DATO IN AL NELLA MPU
PUTDATA         PROC    FAR               ;DATA IS IN AL
                PUSH    DX
                MOV     AH,AL           ;SAVE AL
                MOV     DX,STATPORT     ;DX=STATPORT=COMPORT
LOOP2:          IN      AL,DX           ;READ STATUS
                TEST    AL,DRR          ;TEST BIT 6
                JNZ     LOOP2           ;IF BIT 6=1 THEN NOT READY
                DEC     DX              ;ELSE DX=DATAPORT
                MOV     AL,AH           ;RESTORE ACUMULATOR
                OUT     DX,AL           ;PUT TO MPU-401 DTATPORT
                POP     DX
                RET                     ;RETURN TO CALLER
PUTDATA         ENDP
 
                ;CALCOLA PARITA DI UN BLOCCO DI 3+64 BYTES
                ;CON OFFSET IN BX
PARIT           PROC    FAR
                PUSH    AX
                PUSH    DX
                PUSH    SI
                XOR     AX,AX
                XOR     SI,SI
                CLC
PPP:            MOV     DL,[BX][SI]
                ADD     AL,DL
                INC     SI
                CMP     SI,67
                JL      PPP
                NEG     AL
                MOV     [BX]+67,AL
                POP     SI
                POP     DX
                POP     AX
                RET
PARIT           ENDP
 
                ;MPU PRONTA PER EXCLUSIVE MESSAGES I/O
INITMIDI        PROC    FAR
                MOV     COMBFR,0FFH             ;RESET
                CALL    PUTCMD
                MOV     COMBFR,97H              ;MIDI EXCLUSIVE ON
                CALL    PUTCMD
                RET
INITMIDI        ENDP
 
                ;RICEVE VIA MIDI DAL ROLAND D 50
                ;64 BYTES DA ADDRESS1, 2, 3 E LI METTE IN MEMORIA
                ;CON OFFSET IN BX ; DA POI E BX=0 SE OK SE NO BX=FF
BECCABLOCCO     PROC    FAR
                PUSH    SI
                CALL    GETDATA                 ;SCARTA  FF
                CMP     AL,0FFH
                JNE     BBBERR
                CALL    GETDATA                 ;        F0
                CMP     AL,0F0H
                JNE     BBBERR
                CALL    GETDATA                 ;        41 ROLAND ID
                CMP     AL,041H
                JNE     BBBERR
                CALL    GETDATA                 ;        00
                CMP     AL,0H
                JNE     BBBERR
                CALL    GETDATA                 ;        14 D 50
                CMP     AL,014H
                JNE     BBBERR
                CALL    GETDATA                 ;        DT1
                CMP     AL,DT1
                JNE     BBBERR
                CALL    GETDATA                 ;        ADDRESS
                CMP     AL,ADDRESS1
                JNE     BBBERR
                CALL    GETDATA                 ;        ADDRESS
                CMP     AL,ADDRESS2
                JNE     BBBERR
                CALL    GETDATA                 ;        ADDRESS
                CMP     AL,ADDRESS3
                JNE     BBBERR
 
                MOV     SI,0H
BBB:            CALL    GETDATA
                CMP     AL,ENDEXCLU
                JE      BBBERR
                MOV     [BX][SI],AL
                INC     SI
                CMP     SI,40H
                JLE     BBB
                CALL    GETDATA                 ;SCARTA ENDEXCLU
                CMP     AL,ENDEXCLU
                JNE     BBBERR
                MOV     BX,0
                POP     SI
                RET
BBBERR:         MOV     BX,0FFH
                POP     SI
                RET
BECCABLOCCO     ENDP
 
                ;CAPPELLO PER EXCLUSIVE MESSAGE
EXCLUMIDI       PROC    FAR
                PUSH    AX
                PUSH    BX
                MOV     COMBFR,0DFH             ;VOGLIO
                CALL    PUTCMD                  ;  SPEDIRE MESSAGGIO
                MOV     AL,0F0H                 ; SYSTEM EXCLUSIVE
                CALL    PUTDATA                 ;    INIZIO
                MOV     AL,41H                  ;ROLAND ID
                CALL    PUTDATA
                MOV     AL,00H                  ;DEVICE ID MIDI = 1
                CALL    PUTDATA
                MOV     AL,14H                  ;D50
                CALL    PUTDATA
                POP     BX
                POP     AX
                RET
EXCLUMIDI       ENDP
 
                ;MESSAGGIO LETTURA 64 BYTE DAL D50 ROLAND
                ;INDIRIZZI ADDRESS1, 2, 3, E PARITY
EXCLUREAD       PROC    FAR
                CALL    EXCLUMIDI               ;CAPPELLO EXCLUSIVE
                MOV     AL,RQ1                  ;REQUEST DATA
                CALL    PUTDATA
                MOV     AL,ADDRESS1             ;ADRESS  UPARZ1
                CALL    PUTDATA
                MOV     AL,ADDRESS2             ;  TEMPORARY
                CALL    PUTDATA
                MOV     AL,ADDRESS3             ;        AREA
                CALL    PUTDATA
                MOV     AL,00H                  ;  64
                CALL    PUTDATA                 ;
                MOV     AL,00H                  ;
                CALL    PUTDATA                 ;
                MOV     AL,40H                  ;
                CALL    PUTDATA                 ;     BYTES
                MOV     AL,PARITY               ;CHECKSUM
                CALL    PUTDATA
                MOV     AL,ENDEXCLU             ; SYSTEM EXCLUSIVE
                CALL    PUTDATA                 ;     FINE
                RET
EXCLUREAD       ENDP
 
                ;LEGGE PATCH DAL ROLAND IN MEMORIA
LEGGIPATCH      PROC   FAR
                PUSH    BX
 
RIFAILEGGI:     MOV     ADDRESS1,00H            ;ADDRESS UPARZ1
                MOV     ADDRESS2,00H
                MOV     ADDRESS3,00H
                MOV     PARITY,40H
                CALL    EXCLUREAD
                MOV     BX,OFFSET UPARZ1
                CALL    BECCABLOCCO
                CMP     BX,0FFH
                JE      RIFAILEGGI
 
                MOV     ADDRESS1,00H            ;ADRESS  UPARZ2
                MOV     ADDRESS2,00H
                MOV     ADDRESS3,40H
                MOV     PARITY,00H
                CALL    EXCLUREAD
                MOV     BX,OFFSET UPARZ2
                CALL    BECCABLOCCO
                CMP     BX,0FFH
                JE      RIFAILEGGI
                JMP     CONTXXX1
 
RIFAILEGGI1:    JMP     RIFAILEGGI              ;SALTO TROPPO LUNGO
 
CONTXXX1:       MOV     ADDRESS1,00H            ;ADRESS UCOMMON
                MOV     ADDRESS2,01H
                MOV     ADDRESS3,00H
                MOV     PARITY,3FH
                CALL    EXCLUREAD
                MOV     BX,OFFSET UCOMMON
                CALL    BECCABLOCCO
                CMP     BX,0FFH
                JE      RIFAILEGGI
 
                MOV     ADDRESS1,00H            ;ADRESS LPARZ1
                MOV     ADDRESS2,01H
                MOV     ADDRESS3,40H
                MOV     PARITY,7FH
                CALL    EXCLUREAD
                MOV     BX,OFFSET LPARZ1
                CALL    BECCABLOCCO
                CMP     BX,0FFH
                JE      RIFAILEGGI1
 
                MOV     ADDRESS1,00H            ;ADRESS LPARZ2
                MOV     ADDRESS2,02H
                MOV     ADDRESS3,00H
                MOV     PARITY,3EH
                CALL    EXCLUREAD
                MOV     BX,OFFSET LPARZ2
                CALL    BECCABLOCCO
                CMP     BX,0FFH
                JE      RIFAILEGGI1
                JMP     CONTXXX2
RIFAILEGGI2:    JMP     RIFAILEGGI1             ;SALTO TROPPO LUNGO
 
CONTXXX2:       MOV     ADDRESS1,00H            ;ADRESS LCOMMON
                MOV     ADDRESS2,02H
                MOV     ADDRESS3,40H
                MOV     PARITY,7EH
                CALL    EXCLUREAD
                MOV     BX,OFFSET LCOMMON
                CALL    BECCABLOCCO
                CMP     BX,0FFH
                JE      RIFAILEGGI2
 
                MOV     ADDRESS1,00H            ;ADRESS PATCH
                MOV     ADDRESS2,03H
                MOV     ADDRESS3,00H
                MOV     PARITY,3DH
                CALL    EXCLUREAD
                MOV     BX,OFFSET PATCH
                CALL    BECCABLOCCO
                CMP     BX,0FFH
                JE      RIFAILEGGI2
 
                POP     BX
                RET
LEGGIPATCH      ENDP
 
                ;MESSAGGIO SCRITTURE 64 BYTE SUL D50 ROLAND
                ;PRECEDUTO DAGLI INDIRIZZI 1, 2, 3, E
                ;SEGUITO DAL DATO DI PARITA
                ;OFFSET DEL BLOCCO DI 3+64+1 DATI IN BX
EXCLUWRITE      PROC    FAR
                CALL    PARIT
                CALL    EXCLUMIDI               ;CAPPELLO EXCLUSIVE
                MOV     AL,DT1                  ;DATA  SET
                CALL    PUTDATA
                PUSH    SI
                XOR     SI,SI
EXXX:           MOV     AL,[BX][SI]
                CALL    PUTDATA
                INC     SI
                CMP     SI,68
                JL      EXXX
                MOV     AL,ENDEXCLU
                CALL    PUTDATA
                POP     SI
                RET
EXCLUWRITE      ENDP
 
                ;SCRIVE PATCH SUL ROLAND DA MEMORIA
SCRIVIPATCH     PROC    FAR
                PUSH    BX
                MOV     BX,OFFSET ADDUPARZ1
                CALL    EXCLUWRITE
                MOV     BX,OFFSET ADDUPARZ2
                CALL    EXCLUWRITE
                MOV     BX,OFFSET ADDUCOMMON
                CALL    EXCLUWRITE
                MOV     BX,OFFSET ADDLPARZ1
                CALL    EXCLUWRITE
                MOV     BX,OFFSET  ADDLPARZ2
                CALL    EXCLUWRITE
                MOV     BX,OFFSET ADDLCOMMON
                CALL    EXCLUWRITE
                MOV     BX,OFFSET ADDPATCH
                CALL    EXCLUWRITE
                POP     BX
                RET
SCRIVIPATCH     ENDP
 
 
 
                ;INIZIALIZZA SCHERMO TESTO A COLORI
INITSCR         PROC    FAR
                PUSH AX
                MOV     AH,0
                MOV     AL,3
                INT 10H                         ;80X25 COLOR ALPHA
                POP  AX
                RET
INITSCR         ENDP
 
                ;procedure varie per stampare, per legggere e scrivere
                ;su files
                ;dati usati in zona stampa e files
 
                ;PROCEDURA CHE STAMPA STRINGA DS:DX
STAMPA          PROC       FAR
                PUSH AX
                PUSH SI
                MOV AH,09H
                INT 21H
                POP SI
                POP AX
                RET
STAMPA          ENDP
 
                ;STAMPA UN CR E UN LF ANDANDO A CAPO
ACAPO           PROC    FAR
                PUSH    DX
                MOV     DX,OFFSET CRLF
                CALL    STAMPA
                POP     DX
                RET
ACAPO           ENDP
 
                ;POSIZIONA 18 RIGA
POSIZIONA1      PROC   FAR
                PUSH    AX
                PUSH    BX
                PUSH    DX
                MOV     BH,0            ;PAG 0
                MOV     DX,1200H        ;RIGA 18 COLONNA 0
                MOV     AH,2            ;SET CURSOR
                INT     10H             ;BIOS CALL
                MOV     DX,OFFSET BLANKLINE
                CALL    STAMPA
                POP     DX
                POP     BX
                POP     AX
                RET
POSIZIONA1      ENDP
 
                ;POSIZIONA 20 RIGA
POSIZIONA2      PROC   FAR
                PUSH    AX
                PUSH    BX
                PUSH    DX
                MOV     BH,0            ;PAG 0
                MOV     DX,1400H        ;RIGA 20 COLONNA 0
                MOV     AH,2            ;SET CURSOR
                INT     10H             ;BIOS CALL
                POP     DX
                POP     BX
                POP     AX
                RET
POSIZIONA2      ENDP
 
                ;PROCEDURA CHE LEGGE DA TASTIERA UN
                ;NOME FILE E LO METTE IN NOMEFILE
LEGGI           PROC    FAR
                PUSH AX                 ;INIZIALIZZAZIONE
                PUSH BX
                PUSH DX
                PUSH SI
                CALL POSIZIONA1
                MOV     DX,OFFSET MESSFILE0
                CALL    STAMPA
                MOV BX,OFFSET NOMEFILE
                MOV SI,0                ;0 CARATTERI LETTI
LL0:            CMP SI,20H              ;LETTI PIU DI 32 CARATTERI ?
                JE LLFINE               ;SE SI ESCI   SE NO
LLK:            MOV AH,07H              ;LEGGE
                INT 21H                 ;      TASTIERA
                CMP AL,'$'              ; $
                JE LLBELL               ;  E' PROIBITO
                CMP AL,00H              ; CODICE ESTESO ?
                JNE LLCH                ;NO: PROSEGUI ESAME
                MOV AH,07H              ;  SI : SCARTA UN CARATTERE
                INT 21H                 ;       E
                JMP LLBELL              ;        SUONA BELL
LLCH:           CMP AL,20H              ;VEDI SE E' UN CARATTERE
                JB LLCR                 ;SE PIU PICCOLO DI 20H
                CMP AL,7EH              ;O SE PIU GRANDE DI 7EH
                JG LLCR                 ;ALLORA VEDI SE E' UN CR (O BS)
                MOV DL,AL               ;SI, E' UN CARATTERE
                MOV AH,02H              ;VA
                INT 21H                 ;   SUL DISPLAY
                MOV [BX+SI],DL          ;VA ANCHE NEL BUFFER
                INC SI                  ;PROSSIMO
                JMP LL0                 ;        CARATTERE ?
LLCR:           CMP AL,0DH              ;E' UN CR ?
                JE LLFINE               ;SE SI ESCI ! SE NO
                CMP AL,08H              ;E' UN BACKSPACE ?
                JNE LLBELL              ;SE NO BELL ! :NON E' ACCETTABILE; SE SI
                CMP SI,0                ;SI PUO' TORNARE INDIETRO?
                JE LLBELL               ;SE NO BELL ! :NON E' ACCETTABILE
                MOV DL,08H              ;SE SI CURSORE
                MOV AH,02H              ;              INDIETRO
                INT 21H                 ;                      SUL DISPLAY
                MOV DL,20H              ; CANCELLA
                MOV AH,02H              ;       PRECEDENTE IMMAGINE
                INT 21H                 ;              CON UM BLANK SUL DISPLAY
                MOV DL,08H              ; E DI NUOVO CURSORE
                MOV AH,02H              ;              INDIETRO
                INT 21H                 ;                      SUL DISPLAY
                DEC SI                  ;DECREMENTA NUMERO CARATTERI
                MOV AL,00H              ;CANCELLA NEL BUFFER
                MOV [BX+SI],AL          ;SCRIVENDO 00
                JMP LL0                 ;E LEGGI PROSSIMO CARATTERE
LLBELL:         MOV DL,07H              ;TASTO INACETTABILE:
                MOV AH,02H              ;SUONA
                INT 21H                 ;    BELL
                JMP     LLK             ;E LEGGI NUOVO TASTO
LLFINE:         CMP  SI,0H              ;NESSUN CARATTERE
                JE   LLBELL
                CMP  SI,20H             ;RIEMPIE IL RESTO DEL BUFFER DI 0
                JGE  LLLFINE
                MOV AL,00H
                MOV [BX+SI],AL          ;VA ANCHE NEL BUFFER
                INC SI                  ;PROSSIMO
                JMP LLFINE
LLLFINE:        POP SI
                POP DX
                POP BX
                POP AX
                RET
LEGGI           ENDP
 
                ;PROCEDURA CHE CHIUDE FILE DI FHANDLE IN FHANDLE
CHIUDIFILE     PROC     FAR
                PUSH    AX
                PUSH    BX
                XOR     AX,AX
                MOV     AH,3EH
                MOV     BX,FHANDLE
                INT     21H                     ;CLOSE FILE
                POP     BX
                POP     AX
                RET
CHIUDIFILE      ENDP
 
                ;PROCEDURA CHE APRE IN SCRITTURA IL FILE
                ;NOME IN NOMEFILE ;SI PONE IL FILE HANDLE IN FHANDLE
APRIS           PROC    FAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    DX
                PUSH    SI
CHIEDI:         CALL    POSIZIONA2              ;RIGA 20
                MOV     AL,01H                  ;SCRITTURA
                MOV     AH,3DH
                MOV     CX,20H
                MOV     DX,OFFSET NOMEFILE
                INT     21H                     ;OPEN FILE
                JNC     ESISTE                  ;SE ESISTE GIA
                CMP     AX,02H                  ;FILE NOT FOUND
                JZ      CREA                    ;ALLORA CREALO
                MOV     DX,OFFSET MESSFILE1     ;DIFFICOLTA VARIE
                CALL    STAMPA
                JMP     AAFINE
CREA:           MOV     CX,20H                  ;ATTRIBUTE BIT
                MOV     AH,3CH
                MOV     CX,20H
                MOV     DX,OFFSET NOMEFILE
                INT     21H                     ;CREATO FILE
                JZ      BENE
                MOV     DX,OFFSET MESSFILE1     ;DIFFICOLTA VARIE
                CALL    STAMPA
                JMP     AAFINE
ESISTE:         MOV     DX,OFFSET MESSFILE2     ;ESISTE FILE
                CALL    STAMPA
                MOV     DX,OFFSET MESSFILE3     ;VUOI SOPRASCRIVERE?
                CALL    STAMPA
                MOV     AH,8H
                INT     21H                     ;LEGGE CARATTERE
                CMP     AL,53H                  ;S
                JZ      CREA
                CMP     AL,73H                  ;s
                JZ      CREA
                CALL    LEGGI
                JMP     CHIEDI                  ;NO= RIDAI NOME FILE
BENE:           MOV     FHANDLE,AX
AAFINE:         POP     SI
                POP     DX
                POP     CX
                POP     BX
                POP     AX
                RET
APRIS           ENDP
 
ENTPT           PROC    FAR                     ;ENTRY POINT FROM DOS
                PUSH    DS                      ;SET UP THE STACK TO HAVE
                XOR     AX,AX                   ; THE DOUBLE WORD VECTOR SO THE
                PUSH    AX                      ;  RETURN WILL GO BACK TO DOS
                MOV     AX,DSEG                 ;SET UP ADDRESSABILITY TO
                MOV     DS,AX                   ; THE DATA SEGMENT
                MOV     ES,AX
 
 
SCELTE:         CALL    INITSCR
                MOV     DX,OFFSET TITOLO
                CALL    STAMPA
                CALL    ACAPO
                MOV     DX,OFFSET MENU
                CALL    STAMPA
                CALL    POSIZIONA1              ;RIGA 18
                MOV     DX,OFFSET MESSFILE7
                CALL    STAMPA
                CALL    INITMIDI
 
VEDITASTO:      CALL    POSIZIONA2              ;RIGA 20
                MOV     AH,06H                  ;SE SI VEDI SE RICHIESTA
                MOV     DL,0FFH
                INT     21H                     ;VEDI MENU......
                JZ      VEDITASTO               ;NULLA= ASPETTA
                CMP     AL,'1'                  ;1=FINE
                JE      FINEPROG1
                CMP     AL,'2'                  ;2=LETTURA PATCH
                JE      LETTURAPR
                CMP     AL,'3'                  ;3=SCRITTURA PATCH
                JE      SCRITTURAPR
                CMP     AL,'4'                  ;4=NOMINA FILE
                JE      NOMINAF
                CMP     AL,'5'                  ;5=LETTURA FILE
                JE      LETTURAF
                CMP     AL,'6'                  ;6=SCRITTURA FILE
                JE      SCRITTURAF
                JMP     VEDITASTO
 
LETTURAPR:      CALL    LEGGIPATCH
                MOV     DX,OFFSET MESSROLAND1
                CALL    STAMPA
                JMP     VEDITASTO
 
SCRITTURAPR:    CALL    SCRIVIPATCH
                MOV     DX,OFFSET MESSROLAND2
                CALL    STAMPA
                JMP     VEDITASTO
 
NOMINAF:        CALL    LEGGI
                JMP     VEDITASTO
 
FINEPROG1:      JMP     FINEPROG
 
LETTURAF:       MOV     AL,00H                  ;LETTURA
                MOV     AH,3DH
                MOV     DX,OFFSET NOMEFILE
                INT     21H                     ;OPEN FILE
                JNC     APERTOLOK               ;SE IL FILE  ESISTE
                MOV     DX,OFFSET MESSFILE5
                CALL    STAMPA
                JMP     VEDITASTO
APERTOLOK:      MOV     FHANDLE,AX
                MOV     BX,FHANDLE
                MOV     CX,560
                MOV     DX,OFFSET ADDUPARZ1
                MOV     AH,3FH
                INT     21H
                JNC     LETTURAOK
                MOV     DX, OFFSET MESSFILE8
                CALL    STAMPA
                CALL    CHIUDIFILE
                JMP     VEDITASTO
LETTURAOK:      CALL    CHIUDIFILE
                MOV     DX,OFFSET MESSFILE6
                CALL    STAMPA
                JMP     VEDITASTO
 
 
SCRITTURAF:     CALL    APRIS                   ;APRE IN SCRITTURA
                MOV     BX,FHANDLE
                MOV     CX,560
                MOV     DX,OFFSET ADDUPARZ1
                MOV     AH,40H
                INT     21H
                CMP     AX,560
                JE      SCRITTURAOK
                CALL    CHIUDIFILE
                MOV     DX,OFFSET BLANKLINE
                CALL    STAMPA
                MOV     DX,OFFSET MESSFILE9
                CALL    STAMPA
                JMP     VEDITASTO
 
SCRITTURAOK:    CALL    CHIUDIFILE
                MOV     BH,0                      ;PAG 0
                MOV     DX,1400H                  ;RIGA 20 COLONNA 0
                MOV     AH,2                      ;SET CURSOR
                MOV     DX,OFFSET BLANKLINE
                CALL    STAMPA
                MOV     DX,OFFSET MESSFILE4
                CALL    STAMPA
                JMP     VEDITASTO
 
FINEPROG:       RET
ENTPT           ENDP                            ;FINE PROGRAMMA
CSEG            ENDS
 
STACK           SEGMENT PARA STACK 'STACK'
                DB      640 DUP("STACK   "),     ;2560 WORD STACK AREA
STACK           ENDS
 
END             ENTPT
